#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
typedef long long ll, i64;
const int N = 2005;
char G[N][N];
int mp[N];
int main()
{
    int T, n;
    scanf("%d", &T);
    for (int t = 1; t <= T; t++)
    {
        scanf("%d", &n);
        printf("Case #%d: ", t);
        if (n * (n - 1) & 3)
            puts("No");
        else
        {
            puts("Yes");
            FIL(G, '0');

            for (int i = 0; i < n; i++) G[i][n] = 0, puts(G[i]);
            for (int i = 0; i < n; i++) printf("%d%c", mp[i], " \n"[i == n - 1]);
        }
    }
    return 0;
}